Module ij
Package ij.gui

# Class TextRoi

java.lang.Object
ij.gui.Roi
ij.gui.TextRoi

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `Iterable<Point>`

public class TextRoi extends Roi
This class is a rectangular ROI containing text.

See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`CENTER`
`static final int`
`LEFT`
`static final int`
`RIGHT`

### Fields inherited from class ij.gui.Roi

`ANGLE, asp_bk, aspect, cachedMask, center, clipboard, clipHeight, clipWidth, clipX, clipY, COMPOSITE, constrain, CONSTRUCTING, defaultColor, FERET_ARRAY_POINTOFFSET, FERET_ARRAYSIZE, fillColor, flattenScale, FREELINE, FREEROI, HANDLE_SIZE, handleColor, ic, ignoreClipRect, imp, instanceColor, LINE, lineWidth, mag, MOVING, MOVING_HANDLE, nonScalable, NORMAL, NOT_PASTING, oldHeight, oldWidth, oldX, oldY, onePixelWide, OVAL, overlay, pasteMode, POINT, POLYGON, POLYLINE, RECTANGLE, RESIZING, ROIColor, stroke, strokeColor, TRACED_ROI, type, updateFullWindow, wideLine, xMax, yMax`

## Constructor Summary

Constructors
Constructor
Description
`TextRoi(double x, double y, double width, double height, String text, Font font)`
Creates a TextRoi using the specified sub-pixel location, size and Font.
`TextRoi(double x, double y, String text)`
Creates a TextRoi using sub-pixel coordinates.
`TextRoi(double x, double y, String text, Font font)`
Creates a TextRoi using the specified sub-pixel location and Font.
`TextRoi(int x, int y, ImagePlus imp)`
`TextRoi(int x, int y, String text)`
Creates a TextRoi using the defaultFont.
`TextRoi(int x, int y, String text, Font font)`
Creates a TextRoi using the specified location and Font.
`TextRoi(int x, int y, String text, Font font, Color color)`
Deprecated.
`TextRoi(String text, double x, double y, Font font)`
Use this constructor as a drop-in replacement for ImageProcessor.drawString().

## Method Summary

Modifier and Type
Method
Description
`void`
`addChar(char c)`
This method is used by the text tool to add typed characters to displayed text selections.
`void`
`clear(ImageProcessor ip)`
`Object`
`clone()`
Returns a copy of this TextRoi.
`static TextRoi`
`create(double x, double y, String text, Font font)`
Obsolete.
`static TextRoi`
`create(String text, double x, double y, Font font)`
Creates a TextRoi using the specified text and location.
`void`
`draw(Graphics g)`
Draws the text on the screen, clipped to the ROI.
`void`
`drawOverlay(Graphics g)`
`void`
`drawPixels(ImageProcessor ip)`
Renders the text on the image.
`double`
`getAngle()`
Overridden by PolygonRoi (angle between first two points), TextRoi (text angle) and Line (line angle).
`boolean`
`getAntialiased()`
Returns the state of the 'antiAlias' instance variable.
`Font`
`getCurrentFont()`
Returns the current font.
`static String`
`getDefaultFontName()`
Returns the name of the default font.
`static int`
`getDefaultFontSize()`
Returns the default font size.
`static int`
`getDefaultFontStyle()`
Returns the default font style.
`boolean`
`getDrawStringMode()`
`static String`
`getFont()`
Deprecated.
Replaced by getDefaultFontName
`static int`
`getGlobalJustification()`
Returns the default text tool justification (LEFT, CENTER or RIGHT).
`int`
`getJustification()`
Returns the value of the 'justification' instance variable (LEFT, CENTER or RIGHT).
`String`
`getMacroCode(String cmd, ImagePlus imp)`
Used by the Recorder for recording the text tool.
`static int`
`getSize()`
Deprecated.
Replaced by getDefaultFontSize
`static int`
`getStyle()`
Deprecated.
Replaced by getDefaultFontStyle
`String`
`getText()`
`protected void`
`handleMouseUp(int screenX, int screenY)`
`static boolean`
`isAntialiased()`
Returns the state of the global 'antialiasedText' variable, which is used by the "Fonts" widget.
`boolean`
`isDrawingTool()`
Returns 'true' if this is an ROI primarily used from drawing (e.g., TextRoi or Arrow).
`void`
`setAngle(double angle)`
`void`
`setAntialiased(boolean antiAlias)`
Sets the 'antiAlias' instance variable.
`static void`
`setAntialiasedText(boolean antialiased)`
Sets the state of the global 'antialiasedText' variable.
`void`
`setCurrentFont(Font font)`
Deprecated.
Replaced by setFont(font)
`static void`
`setDefaultAngle(double angle)`
Sets the default angle.
`static void`
`setDefaultFillColor(Color fillColor)`
Sets the default fill (background) color.
`static void`
`setDefaultFont(Font font)`
Sets the default font.
`static void`
`setDefaultFontSize(int size)`
Sets the default font size.
`void`
`setDrawStringMode(boolean drawStringMode)`
`void`
`setFont(Font font)`
Sets the current font.
`static void`
`setFont(String fontName, int fontSize, int fontStyle)`
Sets the global font face, size and style that will be used by TextROIs interactively created using the text tool.
`static void`
`setFont(String fontName, int fontSize, int fontStyle, boolean antialiased)`
Sets the font face, size, style and antialiasing mode that will be used by TextROIs interactively created using the text tool.
`void`
`setFontSize(int size)`
Sets the size of the current font.
`static void`
`setGlobalJustification(int justification)`
Sets the default text tool justification (LEFT, CENTER or RIGHT).
`void`
`setJustification(int justification)`
Sets the 'justification' instance variable (LEFT, CENTER or RIGHT)
`void`
`setLocation(int x, int y)`
Set the location of the ROI in image coordinates.
`void`
`setPreviousTextRoi(Roi previousRoi)`
`void`
`setText(String text)`

### Methods inherited from class ij.gui.Roi

`abortModification, abortPaste, addRoiListener, clipRectMargin, contains, containsPoint, convertLineToArea, convertToPolygon, copyAttributes, create, create, drawPixels, enableSubPixelResolution, endPaste, equals, getAngle, getAntiAlias, getBoundingRect, getBounds, getColor, getContainedFloatPoints, getContainedPoints, getContourCentroid, getConvexHull, getCornerDiameter, getCPosition, getCurrentPasteMode, getDebugInfo, getDefaultFillColor, getDefaultGroup, getDefaultHandleSize, getDefaultStrokeWidth, getDrawOffset, getFeretsDiameter, getFeretValues, getFillColor, getFloatAngle, getFloatBounds, getFloatConvexHull, getFloatHeight, getFloatPolygon, getFloatPolygon, getFloatWidth, getGroup, getGroupName, getGroupNames, getHandleSize, getHashCode, getImage, getImageID, getInterpolatedPolygon, getInterpolatedPolygon, getInterpolatedPolygon, getInverse, getLength, getListeners, getMagnification, getMask, getName, getPasteMode, getPolygon, getPosition, getPreviousRoi, getProperties, getProperty, getPropertyCount, getPrototypeOverlay, getRotationCenter, getRoundRectArcSize, getScaledStroke, getScaleStrokeWidth, getState, getStatistics, getStroke, getStrokeColor, getStrokeWidth, getTPosition, getType, getTypeAsString, getXBase, getYBase, getZPosition, grow, handleMouseDown, handleMouseDrag, hasHyperStackPosition, isActiveOverlayRoi, isArea, isCursor, isHandle, isInteger, isLine, isLineOrPoint, isVisible, iterator, lineCircleIntersection, magnificationForSubPixel, magnificationForSubPixel, mouseDownInHandle, mouseDragged, mouseMoved, mouseReleased, moveHandle, notifyListeners, nudge, nudgeCorner, offScreenX, offScreenXD, offScreenY, offScreenYD, removeRoiListener, resetDefaultHandleSize, saveGroupNames, screenX, screenXD, screenY, screenYD, setAntiAlias, setBounds, setColor, setCornerDiameter, setDefaultColor, setDefaultGroup, setDefaultStrokeWidth, setDrawOffset, setFillColor, setFlattenScale, setGroup, setGroupName, setGroupNames, setHandleSize, setIgnoreClipRect, setImage, setInstanceColor, setIsCursor, setLineWidth, setLocation, setName, setNonScalable, setPasteMode, setPosition, setPosition, setPosition, setPreviousRoi, setProperties, setProperty, setPrototypeOverlay, setRenderingHint, setRotationCenter, setRoundRectArcSize, setStroke, setStrokeColor, setStrokeWidth, setStrokeWidth, setUnscalableStrokeWidth, showStatus, size, startPaste, subPixelResolution, temporarilyHide, toFloat, toInt, toInt, toIntR, toString, translate, update, updateClipRect, updateWideLine, useLineSubpixelConvention, xor`

### Methods inherited from class java.lang.Object

`finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.lang.Iterable

`forEach, spliterator`

## Field Details

### LEFT

public static final int LEFT

See Also:
  - Constant Field Values

### CENTER

public static final int CENTER

See Also:
  - Constant Field Values

### RIGHT

public static final int RIGHT

See Also:
  - Constant Field Values

## Constructor Details

### TextRoi

public TextRoi(int x, int y, String text)
Creates a TextRoi using the defaultFont.

### TextRoi

public TextRoi(String text, double x, double y, Font font)
Use this constructor as a drop-in replacement for ImageProcessor.drawString().

### TextRoi

public TextRoi(double x, double y, String text)
Creates a TextRoi using sub-pixel coordinates.

### TextRoi

public TextRoi(int x, int y, String text, Font font)
Creates a TextRoi using the specified location and Font.

See Also:
  - `Roi.setStrokeColor(java.awt.Color)`
  - `Roi.setNonScalable(boolean)`
  - `ImagePlus.setOverlay(ij.gui.Overlay)`

### TextRoi

public TextRoi(double x, double y, String text, Font font)
Creates a TextRoi using the specified sub-pixel location and Font.

### TextRoi

public TextRoi(double x, double y, double width, double height, String text, Font font)
Creates a TextRoi using the specified sub-pixel location, size and Font.

### TextRoi

public TextRoi(int x, int y, String text, Font font, Color color)
Deprecated.

### TextRoi

public TextRoi(int x, int y, ImagePlus imp)

## Method Details

### create

public static TextRoi create(String text, double x, double y, Font font)
Creates a TextRoi using the specified text and location.

### create

public static TextRoi create(double x, double y, String text, Font font)
Obsolete.

### addChar

public void addChar(char c)
This method is used by the text tool to add typed characters to displayed text selections.

### drawPixels

public void drawPixels(ImageProcessor ip)
Renders the text on the image. Draws the text in the foreground color if ip.setColor(Color) has not been called.

Overrides:
  `drawPixels` in class `Roi`
See Also:
  - `ImageProcessor.setFont(Font)`
  - `ImageProcessor.setAntialiasedText(boolean)`
  - `ImageProcessor.setColor(Color)`

### draw

public void draw(Graphics g)
Draws the text on the screen, clipped to the ROI.

Overrides:
  `draw` in class `Roi`

### drawOverlay

public void drawOverlay(Graphics g)

Overrides:
  `drawOverlay` in class `Roi`

### getDefaultFontName

public static String getDefaultFontName()
Returns the name of the default font. Use getCurrentFont().getName() to get the name of the font that this TextRoi is using.

### getDefaultFontSize

public static int getDefaultFontSize()
Returns the default font size. Use getCurrentFont().getSize() to get the size of the font that this TextRoi is using.

### getDefaultFontStyle

public static int getDefaultFontStyle()
Returns the default font style. Use getCurrentFont().getStyle() to get the style of the font that this TextRoi is using.

### setFont

public void setFont(Font font)
Sets the current font.

### setFontSize

public void setFontSize(int size)
Sets the size of the current font.

### getCurrentFont

public Font getCurrentFont()
Returns the current font.

### isAntialiased

public static boolean isAntialiased()
Returns the state of the global 'antialiasedText' variable, which is used by the "Fonts" widget.

### setAntialiasedText

public static void setAntialiasedText(boolean antialiased)
Sets the state of the global 'antialiasedText' variable.

### setAntialiased

public void setAntialiased(boolean antiAlias)
Sets the 'antiAlias' instance variable.

### getAntialiased

public boolean getAntialiased()
Returns the state of the 'antiAlias' instance variable.

### setGlobalJustification

public static void setGlobalJustification(int justification)
Sets the default text tool justification (LEFT, CENTER or RIGHT).

### getGlobalJustification

public static int getGlobalJustification()
Returns the default text tool justification (LEFT, CENTER or RIGHT).

### setJustification

public void setJustification(int justification)
Sets the 'justification' instance variable (LEFT, CENTER or RIGHT)

### getJustification

public int getJustification()
Returns the value of the 'justification' instance variable (LEFT, CENTER or RIGHT).

### setFont

public static void setFont(String fontName, int fontSize, int fontStyle)
Sets the global font face, size and style that will be used by TextROIs interactively created using the text tool.

### setFont

public static void setFont(String fontName, int fontSize, int fontStyle, boolean antialiased)
Sets the font face, size, style and antialiasing mode that will be used by TextROIs interactively created using the text tool.

### setDefaultFont

public static void setDefaultFont(Font font)
Sets the default font.

### setDefaultFontSize

public static void setDefaultFontSize(int size)
Sets the default font size.

### setDefaultFillColor

public static void setDefaultFillColor(Color fillColor)
Sets the default fill (background) color.

### setDefaultAngle

public static void setDefaultAngle(double angle)
Sets the default angle.

### handleMouseUp

protected void handleMouseUp(int screenX, int screenY)

Overrides:
  `handleMouseUp` in class `Roi`

### getMacroCode

public String getMacroCode(String cmd, ImagePlus imp)
Used by the Recorder for recording the text tool.

### getText

public String getText()

### setText

public void setText(String text)

### isDrawingTool

public boolean isDrawingTool()
Description copied from class: `Roi`
Returns 'true' if this is an ROI primarily used from drawing (e.g., TextRoi or Arrow).

Overrides:
  `isDrawingTool` in class `Roi`

### clear

public void clear(ImageProcessor ip)

### setLocation

public void setLocation(int x, int y)
Description copied from class: `Roi`
Set the location of the ROI in image coordinates.

Overrides:
  `setLocation` in class `Roi`

### clone

public Object clone()
Returns a copy of this TextRoi.

Overrides:
  `clone` in class `Roi`

### getAngle

public double getAngle()
Description copied from class: `Roi`
Overridden by PolygonRoi (angle between first two points), TextRoi (text angle) and Line (line angle).

Overrides:
  `getAngle` in class `Roi`

### setAngle

public void setAngle(double angle)

### getDrawStringMode

public boolean getDrawStringMode()

### setDrawStringMode

public void setDrawStringMode(boolean drawStringMode)

### setPreviousTextRoi

public void setPreviousTextRoi(Roi previousRoi)

### getFont

public static String getFont()
Deprecated.
Replaced by getDefaultFontName

### getSize

public static int getSize()
Deprecated.
Replaced by getDefaultFontSize

### getStyle

public static int getStyle()
Deprecated.
Replaced by getDefaultFontStyle

### setCurrentFont

public void setCurrentFont(Font font)
Deprecated.
Replaced by setFont(font)